import 'dart:async';
import 'dart:math' as math;

import 'package:flutter/material.dart';
import 'package:sensors_plus/sensors_plus.dart';
import 'package:vector_math/vector_math.dart';
class CompassByLoc extends StatefulWidget {
  const CompassByLoc({Key? key}) : super(key: key);

  @override
  State<CompassByLoc> createState() => _CompassByLocState();
}

class _CompassByLocState extends State<CompassByLoc> {

   @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(),
      body: Container(
        child: StreamBuilder<MagnetometerEvent>(
          stream: magnetometerEvents,
          builder: (context,dataSnapshot) {
            if(dataSnapshot.connectionState==ConnectionState.waiting){
              return const Center(
                child: CircularProgressIndicator(),
              );
            }
            else if(dataSnapshot.data!=null) {
              double x = dataSnapshot.data?.x??0;
              double y = dataSnapshot.data?.y??0;
              double z = dataSnapshot.data?.z??0;

              // create a vector from the sensor values
              Vector3 vector = Vector3(x, y, z);

              // calculate the heading (in degrees) from the vector
              double heading = math.atan2(-vector.z, vector.y) * 180 / math.pi;
              return Center(
                child: Transform.rotate(
                  angle: -(heading ?? 0) * math.pi / 180,
                  child: Image.asset("assets/images/compass.png"),
                ),
              );
            }else{
              return SizedBox.shrink();
            }
          }
        ),
      ),
    );
  }
}
